(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     40147,        738]
NotebookOptionsPosition[     35550,        665]
NotebookOutlinePosition[     35968,        681]
CellTagsIndexPosition[     35925,        678]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Component Generation", "Title",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.7627280721197987`*^9, 3.762728097973707*^9}, {
  3.7747940713991594`*^9, 
  3.774794098262859*^9}},ExpressionUUID->"5ee7c9b3-61b3-495d-947e-\
36f10d487fd4"],

Cell[BoxData[
 RowBox[{"<<", "C:\\\\Hopsan\\Compgen\\CompgenNG.mx"}]], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.525533906765625*^9, 3.525533914734375*^9}, 
   3.577601924150117*^9, 3.753532820170209*^9, 3.753532868377143*^9, 
   3.762728078322752*^9},
 CellLabel->"In[64]:=",ExpressionUUID->"fb626f91-feab-4a07-b722-dbbcc151c4cc"],

Cell[BoxData[
 RowBox[{"path", "=", 
  RowBox[{"ToFileName", "[", 
   RowBox[{"{", 
    RowBox[{
    "\"\<H:\>\"", ",", "\"\<PettersDropbox\>\"", ",", "\"\<Dropbox\>\"", ",", 
     "\"\<HopsanComponents\>\"", ",", "\"\<ActivityDiagram\>\"", ",", 
     "\"\<ActivityDiagram\>\""}], "}"}], "]"}]}]], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.754985113560959*^9, 3.754985114033472*^9}, {
   3.757063485852047*^9, 3.757063485995899*^9}, 3.76272807832475*^9, {
   3.7747826878685503`*^9, 3.774782689771587*^9}, {3.7747982976294117`*^9, 
   3.774798305629897*^9}},
 CellLabel->"In[65]:=",ExpressionUUID->"f08428ac-a507-4dcf-b70e-fed094d55f5a"]
}, Open  ]],

Cell[BoxData["\<\"H:\\\\PettersDropbox\\\\Dropbox\\\\HopsanComponents\\\\\
ActivityDiagram\\\\ActivityDiagram\\\\\"\>"], "Output",
 CellChangeTimes->{3.7839336026642847`*^9},
 CellLabel->"Out[65]=",ExpressionUUID->"1a41fbbe-4cae-413c-9835-7598e46f812a"],

Cell[BoxData[
 RowBox[{"path", "=", 
  RowBox[{"ToFileName", "[", 
   RowBox[{"{", 
    RowBox[{
    "\"\<C:\>\"", ",", "\"\<Users\>\"", ",", "\"\<petkr14\>\"", ",", 
     "\"\<Dropbox\>\"", ",", "\"\<HopsanComponents\>\"", ",", 
     "\"\<StateMachine0\>\"", ",", "\"\<ActivityDiagram\>\"", ",", 
     "\"\<ActivityDiagram\>\""}], "}"}], "]"}]}]], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{3.7839335960458083`*^9},
 CellLabel->"In[66]:=",ExpressionUUID->"3942318d-c5ab-4bbb-b9f9-af1d93363738"],

Cell[BoxData["\<\"C:\\\\Users\\\\petkr14\\\\Dropbox\\\\HopsanComponents\\\\\
StateMachine0\\\\ActivityDiagram\\\\ActivityDiagram\\\\\"\>"], "Output",
 CellChangeTimes->{3.783933602781729*^9},
 CellLabel->"Out[66]=",ExpressionUUID->"6e065920-ee9c-4f29-ad85-37cfb9be7634"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Off", "[", 
  RowBox[{"General", "::", "\"\<spell1\>\""}], "]"}]], "Input",
 PageWidth->WindowWidth,
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{3.76272807832475*^9},
 CellLabel->"In[67]:=",ExpressionUUID->"96c62941-67ee-4f41-b96b-bc238faf7f2f"],

Cell["ActivityDiagram Decision", "Section",
 PageWidth->WindowWidth,
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.516086509*^9, 3.51608651040625*^9}, 3.52240314025*^9, {
   3.7535317970818443`*^9, 3.7535318239181423`*^9}, 3.754991191627206*^9, {
   3.755021377179763*^9, 3.7550213776352935`*^9}, {3.7551010992251368`*^9, 
   3.7551011067453823`*^9}, {3.7552806950102434`*^9, 3.755280707559305*^9}, {
   3.7552808134950852`*^9, 3.755280835886998*^9}, 3.7571794848474817`*^9, {
   3.7653654640344186`*^9, 3.765365465561455*^9}, {3.7747937389060163`*^9, 
   3.7747937761626363`*^9}, 
   3.7747942097903123`*^9},ExpressionUUID->"579c246d-7234-4bbc-a83d-\
653b42f152d9"],

Cell["\<\
Event trigger for state machines. The flow is triggered on a positive flank \
in event (should be a value 0 or 1). The flow qpn1,qpn2 and qpn3, are either \
0 or 1 in one time step. The state variables spn1, spn2 and spn3 are either 0 \
or 1.\
\>", "Text",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.7535320908646555`*^9, 3.753532282365305*^9}, {
   3.7549912370203238`*^9, 3.7549912440350904`*^9}, {3.774793947624714*^9, 
   3.7747940079196377`*^9}, 
   3.774794209791312*^9},ExpressionUUID->"bdc3e281-aa00-44be-ae84-\
967524ca58f1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"domain", "=", "\"\<ActivityDiagram\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"displayName", "=", "\"\<Decision\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{"brief", "=", "\"\<If selection for state machine\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"componentType", "=", "\"\<ComponentQ\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{"author", "=", "\"\<Petter Krus <petter.krus@liu.se>\>\""}], 
  ";"}], "\n", 
 RowBox[{"coauthor", "=", 
  "\"\<Robert Braun <robert.braun@liu.se>, Emilia Villani\>\""}], "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "affiliation", " ", "=", " ", 
   "\"\<Division of Fluid and Mechatronic Systems, Link\[ODoubleDot]ping \
University\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetFilenames", "[", 
   RowBox[{"path", ",", "domain", ",", "displayName"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ResetComponentVariables", "[", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Date", "[", "]"}]}], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.513785360140625*^9, 3.513785397734375*^9}, 
   3.5137854683125*^9, 3.5153945210188417`*^9, {3.51608651940625*^9, 
   3.516086528875*^9}, {3.522403083546875*^9, 3.52240310159375*^9}, {
   3.575772870974745*^9, 3.5757728916915812`*^9}, {3.60584801018426*^9, 
   3.60584801687926*^9}, {3.753531830402015*^9, 3.7535318497890887`*^9}, {
   3.7535329032428656`*^9, 3.7535329063911552`*^9}, {3.7549912128203564`*^9, 
   3.7549912207072244`*^9}, {3.755021382930831*^9, 3.7550214033397913`*^9}, {
   3.755101114360531*^9, 3.7551011191455984`*^9}, {3.755101168038189*^9, 
   3.7551011721439543`*^9}, {3.755280720238233*^9, 3.7552807489446363`*^9}, {
   3.7552808264926853`*^9, 3.7552808399757824`*^9}, 3.757179487096159*^9, {
   3.7653654729463096`*^9, 3.7653654743850803`*^9}, {3.7747937498138437`*^9, 
   3.7747937597243137`*^9}, 3.774794209791312*^9, 3.7753178059060497`*^9},
 CellLabel->"In[68]:=",ExpressionUUID->"c12350b7-5012-4a2e-bec0-d7181fc31046"],

Cell[BoxData["\<\"Robert Braun <robert.braun@liu.se>, Emilia Villani\"\>"], \
"Output",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.7535328848148966`*^9, 3.7535329121154985`*^9}, 
   3.7535331327717113`*^9, {3.755021329018415*^9, 3.7550213665227485`*^9}, 
   3.7550303361670485`*^9, 3.75509948840012*^9, 3.755099526958366*^9, 
   3.7550997876705723`*^9, {3.755099820283948*^9, 3.75509982687815*^9}, {
   3.7551002782832775`*^9, 3.7551002917983437`*^9}, 3.7551003528322644`*^9, 
   3.755100442002329*^9, 3.755100477968249*^9, 3.755100585680197*^9, 
   3.755101132745575*^9, 3.7551013081956844`*^9, {3.7551015577480392`*^9, 
   3.7551015772489343`*^9}, 3.7551017587433357`*^9, 3.7551045059350233`*^9, 
   3.7552831648088813`*^9, 3.757179814550045*^9, {3.757437878596813*^9, 
   3.75743788971733*^9}, 3.7574481003314004`*^9, 3.763203498934745*^9, 
   3.763203573039265*^9, 3.7632048221363173`*^9, 3.7632050097741833`*^9, 
   3.765365811250082*^9, 3.774794209791312*^9, 3.774795582092512*^9, 
   3.7748613015248985`*^9, 3.774861875518277*^9, 3.7748629660436335`*^9, 
   3.775317823771299*^9, 3.7839336029684124`*^9},
 CellLabel->"Out[73]=",ExpressionUUID->"565c5faf-895b-4afd-a9ec-6c5289b0951e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2019", ",", "11", ",", "28", ",", "13", ",", "40", ",", 
   "2.8902734`8.21351390967783"}], "}"}]], "Output",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.7535328848148966`*^9, 3.7535329121154985`*^9}, 
   3.7535331327717113`*^9, {3.755021329018415*^9, 3.7550213665227485`*^9}, 
   3.7550303361670485`*^9, 3.75509948840012*^9, 3.755099526958366*^9, 
   3.7550997876705723`*^9, {3.755099820283948*^9, 3.75509982687815*^9}, {
   3.7551002782832775`*^9, 3.7551002917983437`*^9}, 3.7551003528322644`*^9, 
   3.755100442002329*^9, 3.755100477968249*^9, 3.755100585680197*^9, 
   3.755101132745575*^9, 3.7551013081956844`*^9, {3.7551015577480392`*^9, 
   3.7551015772489343`*^9}, 3.7551017587433357`*^9, 3.7551045059350233`*^9, 
   3.7552831648088813`*^9, 3.757179814550045*^9, {3.757437878596813*^9, 
   3.75743788971733*^9}, 3.7574481003314004`*^9, 3.763203498934745*^9, 
   3.763203573039265*^9, 3.7632048221363173`*^9, 3.7632050097741833`*^9, 
   3.765365811250082*^9, 3.774794209791312*^9, 3.774795582092512*^9, 
   3.7748613015248985`*^9, 3.774861875518277*^9, 3.7748629660436335`*^9, 
   3.775317823771299*^9, 3.7839336029684124`*^9},
 CellLabel->"Out[77]=",ExpressionUUID->"de71617e-5329-4b4c-90a5-a75119ee28f7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nodeConnections", "=", 
   RowBox[{"{", "\[IndentingNewLine]", "\t", 
    RowBox[{
     RowBox[{"PetriNetQnode", "[", 
      RowBox[{"pn1", ",", "0.", ",", "\"\<PetriNet port 1\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "\t", 
     RowBox[{"PetriNetQnode", "[", 
      RowBox[{"pn2", ",", "0.", ",", "\"\<PetriNet port 2\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "\t", 
     RowBox[{"PetriNetQnode", "[", 
      RowBox[{"pn3", ",", "0.", ",", "\"\<PetriNet port 3\>\""}], "]"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.515774261203125*^9, 3.515774262703125*^9}, {
   3.51603387128125*^9, 3.51603387178125*^9}, {3.522403633375*^9, 
   3.522403641375*^9}, 3.53224891889497*^9, 3.762728078328746*^9, {
   3.7747810345452485`*^9, 3.774781058090841*^9}, {3.7747823489520864`*^9, 
   3.774782356258823*^9}, {3.7747938144278283`*^9, 3.774793819809081*^9}, {
   3.7753178114071627`*^9, 3.7753178126798496`*^9}},
 CellLabel->"In[78]:=",ExpressionUUID->"2096f5b3-005e-4e58-a8bb-ee5cca97f503"],

Cell[BoxData[
 RowBox[{
  RowBox[{"inputVariables", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "event2", ",", " ", "0.", ",", " ", "double", ",", " ", "\"\<\>\"", ",",
        " ", "\"\<trigger on positive flank\>\""}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "event3", ",", " ", "0.", ",", " ", "double", ",", " ", "\"\<\>\"", ",",
        " ", "\"\<trigger on positive flank\>\""}], "}"}]}], "\n", "   ", 
    "}"}]}], ";"}]], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.51862830415625*^9, 3.51862836625*^9}, 
   3.522403352671875*^9, 3.522403646703125*^9, {3.5320892483732347`*^9, 
   3.5320892502013865`*^9}, {3.532248903689953*^9, 3.5322489076082892`*^9}, {
   3.7535310770227385`*^9, 3.7535310789444804`*^9}, {3.753531860881981*^9, 
   3.7535318903088574`*^9}, 3.754993159322428*^9, {3.75499320303636*^9, 
   3.754993203039356*^9}, {3.7550211707735662`*^9, 3.7550212091549945`*^9}, {
   3.7550213368433485`*^9, 3.755021361930483*^9}, {3.7551002377111077`*^9, 
   3.755100273841857*^9}, {3.755100337895664*^9, 3.7551003437256527`*^9}, 
   3.7551004328008165`*^9, {3.755100578582515*^9, 3.755100578669425*^9}, {
   3.7551014342164*^9, 3.7551014381583347`*^9}, {3.755101493431348*^9, 
   3.755101495198529*^9}, {3.755101546333806*^9, 3.7551015485175548`*^9}, 
   3.755280763360775*^9, {3.757179509086452*^9, 3.7571795220091095`*^9}, {
   3.757179560664197*^9, 3.7571795619668493`*^9}, 3.7747942097923093`*^9},
 CellLabel->"In[79]:=",ExpressionUUID->"84b1787a-183b-4920-a69d-4df94c20bba2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"inputParameters", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "diffevent", ",", "0.", ",", "double", ",", "\"\<\>\"", ",", 
      "\"\<Trigg on level (0) or flank (1)\>\""}], "}"}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{3.7747942097923093`*^9},
 CellLabel->"In[80]:=",ExpressionUUID->"0c74128b-2532-4223-a2a4-740b1043b57b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"initialExpressions", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"oldEvent2", "\[Equal]", "event2"}], ",", "\[IndentingNewLine]", 
     RowBox[{"oldEvent3", "\[Equal]", "event3"}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}]], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.7655533786392612`*^9, 3.765553382135273*^9}, 
   3.765553549418847*^9, {3.765555534690852*^9, 3.765555545228863*^9}, 
   3.7749722366624327`*^9},
 CellLabel->"In[81]:=",ExpressionUUID->"e5511e4a-3353-4719-a540-40dff57756df"],

Cell[BoxData[
 RowBox[{
  RowBox[{"expressions", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"dEvent2", "==", 
      RowBox[{"onPositive", "[", 
       RowBox[{"event2", "-", 
        RowBox[{"diffevent", " ", "oldEvent2"}], "-", "0.5"}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"dEvent3", "==", 
      RowBox[{"onPositive", "[", 
       RowBox[{"event3", "-", 
        RowBox[{"diffevent", " ", "oldEvent3"}], "-", "0.5"}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"qpn2", "\[Equal]", 
      RowBox[{"dEvent2", " ", 
       RowBox[{"onPositive", "[", 
        RowBox[{"spn1", "-", "spn2"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"qpn3", "\[Equal]", 
      RowBox[{"dEvent3", " ", 
       RowBox[{"onPositive", "[", 
        RowBox[{"spn1", "-", "spn3"}], "]"}], 
       RowBox[{"(", 
        RowBox[{"1", "-", "qpn2"}], ")"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"qpn1", "\[Equal]", 
      RowBox[{"-", 
       RowBox[{"onPositive", "[", 
        RowBox[{"qpn2", "+", "qpn3", "-", "0.5"}], "]"}]}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"oldEvent2", "==", "event2"}], ",", "\[IndentingNewLine]", 
     RowBox[{"oldEvent3", "==", "event3"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.532248478932937*^9, 3.532248638440628*^9}, {
   3.571914197748662*^9, 3.5719142149866924`*^9}, {3.7535310915842247`*^9, 
   3.7535311473072805`*^9}, {3.7535315340759363`*^9, 3.753531580504115*^9}, {
   3.7535316152480335`*^9, 3.7535316172745495`*^9}, {3.7535316889611306`*^9, 
   3.7535317847886696`*^9}, {3.7535320068457546`*^9, 
   3.7535320299450684`*^9}, {3.7535324291297054`*^9, 3.7535324760913725`*^9}, 
   3.7535329786896353`*^9, {3.754991269059291*^9, 3.7549913100180607`*^9}, {
   3.7549930139652925`*^9, 3.754993017798341*^9}, {3.755021228933604*^9, 
   3.755021278948039*^9}, {3.7550991045618577`*^9, 3.755099112472701*^9}, {
   3.755099168634801*^9, 3.7550992698544407`*^9}, {3.7550993152716155`*^9, 
   3.755099358142417*^9}, {3.7550994059501266`*^9, 3.7550994196639867`*^9}, 
   3.7550995178927135`*^9, 3.7551004381113434`*^9, 3.7551045016584373`*^9, {
   3.7552807682737083`*^9, 3.755280770768137*^9}, {3.757179542215247*^9, 
   3.757179752373249*^9}, {3.7574378471313057`*^9, 3.757437865501336*^9}, 
   3.757448097268563*^9, {3.7595689924690266`*^9, 3.759568992946535*^9}, {
   3.76320347871198*^9, 3.763203482457853*^9}, {3.7632045298557444`*^9, 
   3.7632045309021263`*^9}, {3.763204981137596*^9, 3.7632049858229017`*^9}, {
   3.7655555913655677`*^9, 3.765555595465226*^9}, {3.774793862135045*^9, 
   3.7747938673846397`*^9}, {3.7747939015294933`*^9, 3.7747939124081473`*^9}, 
   3.7747942097923093`*^9},
 CellLabel->"In[82]:=",ExpressionUUID->"3cfb1a01-c132-42a5-9718-0d816c76266d"],

Cell[BoxData["file"], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.75509983772097*^9, 3.7550998382344413`*^9}, 
   3.7747942097923093`*^9},
 CellLabel->"In[83]:=",ExpressionUUID->"2ac98d27-7834-4af5-8633-0d47fd58d28b"],

Cell[BoxData["\<\"C:\\\\Users\\\\petkr14\\\\Dropbox\\\\HopsanComponents\\\\\
StateMachine0\\\\ActivityDiagram\\\\ActivityDiagram\\\\\
ActivityDiagramDecision.hpp\"\>"], "Output",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{
  3.755099839466172*^9, {3.7551002784451103`*^9, 3.755100291957179*^9}, 
   3.7551003529920993`*^9, 3.7551004421621637`*^9, 3.7551004781310806`*^9, 
   3.7551005858670053`*^9, 3.7551011329084063`*^9, 3.755101308363512*^9, {
   3.755101557911868*^9, 3.7551015773578196`*^9}, 3.755101758976097*^9, 
   3.755104506123829*^9, 3.755283164925761*^9, 3.7571798146669254`*^9, {
   3.757437883899338*^9, 3.7574378898442*^9}, 3.7574481005791445`*^9, 
   3.763203499779257*^9, 3.7632035734960213`*^9, 3.763204822587062*^9, 
   3.7632050102229333`*^9, 3.7653658113939333`*^9, 3.7747942097933083`*^9, 
   3.774795582508052*^9, 3.7748629664251757`*^9, 3.775317824124934*^9, 
   3.7839336034559755`*^9},
 CellLabel->"Out[83]=",ExpressionUUID->"b052cbd8-eb76-426e-934e-f2f7007b974a"],

Cell[BoxData[
 RowBox[{"Compgen", "[", "file", "]"}]], "Input",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{3.7747942097933083`*^9},
 CellLabel->"In[84]:=",ExpressionUUID->"15f971df-cb2f-4ac0-8bbd-ca375d983568"],

Cell[BoxData[
 TemplateBox[{
  "XMLElement","cntsList",
   "\"\\!\\(\\*RowBox[{\\\"XMLElement\\\", \\\"[\\\", \
RowBox[{\\\"\\\\\\\"modelobject\\\\\\\"\\\", \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"\\\\\\\"typename\\\\\\\"\\\", \\\"\[Rule]\\\", \\\"\\\\\\\
\"ActivityDiagramDecision\\\\\\\"\\\"}], \\\",\\\", \
RowBox[{RowBox[{\\\"\\\\\\\"di\\\\\\\"\\\", \\\"\[Ellipsis]\\\", \
\\\"\\\\\\\"ame\\\\\\\"\\\"}], \\\"\[Rule]\\\", \
RowBox[{\\\"\\\\\\\"\\\\\\\"\\\", \\\"\[Ellipsis]\\\", \\\"\\\\\\\"\\\\\\\"\\\
\"}]}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"XMLElement\\\", \\\"[\\\", RowBox[{\\\"\\\\\\\"icon\\\\\\\
\"\\\", \\\",\\\", RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"\\\\\\\"isopath\\\\\
\\\"\\\", \\\"\[Rule]\\\", \
\\\"\\\\\\\"ActivityDiagramDecision.svg\\\\\\\"\\\"}], \\\",\\\", \
RowBox[{\\\"\\\\\\\"iconrotation\\\\\\\"\\\", \\\"\[Rule]\\\", \\\"\\\\\\\"ON\
\\\\\\\"\\\"}], \\\",\\\", RowBox[{\\\"\\\\\\\"userpath\\\\\\\"\\\", \\\"\
\[Rule]\\\", \\\"\\\\\\\"ActivityDiagramDecision.svg\\\\\\\"\\\"}]}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"}\\\"}]}], \\\"]\\\"}], \\\",\\\", \
RowBox[{\\\"XMLElement\\\", \\\"[\\\", \
RowBox[{\\\"\\\\\\\"portpositions\\\\\\\"\\\", \\\",\\\", RowBox[{\\\"{\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"XMLElement\\\", \\\"[\\\", RowBox[{\\\"\\\\\\\"portpose\\\
\\\\\"\\\", \\\",\\\", RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"\\\\\\\"x\\\\\\\
\"\\\", \\\"\[Rule]\\\", \\\"\\\\\\\"0\\\\\\\"\\\"}], \\\",\\\", RowBox[{\\\"\
\\\\\\\"y\\\\\\\"\\\", \\\"\[Rule]\\\", \\\"0.25`\\\"}], \\\",\\\", \
RowBox[{\\\"\\\\\\\"a\\\\\\\"\\\", \\\"\[Rule]\\\", \
\\\"\\\\\\\"0\\\\\\\"\\\"}], \\\",\\\", RowBox[{\\\"\\\\\\\"name\\\\\\\"\\\", \
\\\"\[Rule]\\\", \\\"\\\\\\\"Ppn1\\\\\\\"\\\"}]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"}\\\"}]}], \\\"]\\\"}], \\\",\\\", RowBox[{\\\"\
\[LeftSkeleton]\\\", \\\"3\\\", \\\"\[RightSkeleton]\\\"}], \\\",\\\", \
RowBox[{\\\"XMLElement\\\", \\\"[\\\", RowBox[{\\\"\\\\\\\"portpose\\\\\\\"\\\
\", \\\",\\\", RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"\\\\\\\"x\\\\\\\"\\\", \
\\\"\[Rule]\\\", \\\"0.6666666666666666`\\\"}], \\\",\\\", RowBox[{\\\"\\\\\\\
\"y\\\\\\\"\\\", \\\"\[Rule]\\\", \\\"\\\\\\\"0\\\\\\\"\\\"}], \\\",\\\", \
RowBox[{\\\"\\\\\\\"a\\\\\\\"\\\", \\\"\[Rule]\\\", \\\"\\\\\\\"270\\\\\\\"\\\
\"}], \\\",\\\", RowBox[{\\\"\\\\\\\"name\\\\\\\"\\\", \\\"\[Rule]\\\", \
\\\"\\\\\\\"event3\\\\\\\"\\\"}]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"}\\\"}]}], \\\"]\\\"}]}], \\\"}\\\"}]}], \
\\\"]\\\"}]}], \\\"}\\\"}]}], \\\"]\\\"}]\\) in \
\\!\\(\\*RowBox[{\\\"XMLElement\\\", \\\"[\\\", \
RowBox[{\\\"\\\\\\\"hopsanobjectappearance\\\\\\\"\\\", \\\",\\\", RowBox[{\\\
\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\[RightSkeleton]\\\"}], \\\",\\\", \
RowBox[{\\\"XMLElement\\\", \\\"[\\\", \
RowBox[{\\\"\\\\\\\"modelobject\\\\\\\"\\\", \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{RowBox[{RowBox[{\\\"\\\\\\\"t\\\\\\\"\\\", \\\"\[Ellipsis]\\\", \
\\\"\\\\\\\"e\\\\\\\"\\\"}], \\\"\[Rule]\\\", \
RowBox[{\\\"\\\\\\\"\\\\\\\"\\\", \\\"\[Ellipsis]\\\", \\\"\\\\\\\"\\\\\\\"\\\
\"}]}], \\\",\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\
\[RightSkeleton]\\\"}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"XMLElement\\\", \\\"[\\\", RowBox[{\\\"\\\\\\\"icon\\\\\\\
\"\\\", \\\",\\\", RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"\\\\\\\"isopath\\\\\
\\\"\\\", \\\"\[Rule]\\\", \
\\\"\\\\\\\"ActivityDiagramDecision.svg\\\\\\\"\\\"}], \\\",\\\", \
RowBox[{\\\"\\\\\\\"iconrotation\\\\\\\"\\\", \\\"\[Rule]\\\", \\\"\\\\\\\"ON\
\\\\\\\"\\\"}], \\\",\\\", RowBox[{\\\"\\\\\\\"userpath\\\\\\\"\\\", \\\"\
\[Rule]\\\", \\\"\\\\\\\"ActivityDiagramDecision.svg\\\\\\\"\\\"}]}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"}\\\"}]}], \\\"]\\\"}], \\\",\\\", \
RowBox[{\\\"XMLElement\\\", \\\"[\\\", \
RowBox[{\\\"\\\\\\\"portpositions\\\\\\\"\\\", \\\",\\\", RowBox[{\\\"{\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"XMLElement\\\", \\\"[\\\", RowBox[{\\\"\\\\\\\"portpose\\\
\\\\\"\\\", \\\",\\\", RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"\\\\\\\"x\\\\\\\
\"\\\", \\\"\[Rule]\\\", \\\"\\\\\\\"0\\\\\\\"\\\"}], \\\",\\\", RowBox[{\\\"\
\\\\\\\"y\\\\\\\"\\\", \\\"\[Rule]\\\", \\\"0.25`\\\"}], \\\",\\\", \
RowBox[{\\\"\\\\\\\"a\\\\\\\"\\\", \\\"\[Rule]\\\", \
\\\"\\\\\\\"0\\\\\\\"\\\"}], \\\",\\\", RowBox[{\\\"\\\\\\\"name\\\\\\\"\\\", \
\\\"\[Rule]\\\", \\\"\\\\\\\"Ppn1\\\\\\\"\\\"}]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"}\\\"}]}], \\\"]\\\"}], \\\",\\\", RowBox[{\\\"\
\[LeftSkeleton]\\\", \\\"3\\\", \\\"\[RightSkeleton]\\\"}], \\\",\\\", \
RowBox[{\\\"XMLElement\\\", \\\"[\\\", RowBox[{\\\"\\\\\\\"portpose\\\\\\\"\\\
\", \\\",\\\", RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"\\\\\\\"x\\\\\\\"\\\", \
\\\"\[Rule]\\\", \\\"0.6666666666666666`\\\"}], \\\",\\\", RowBox[{\\\"\\\\\\\
\"y\\\\\\\"\\\", \\\"\[Rule]\\\", \\\"\\\\\\\"0\\\\\\\"\\\"}], \\\",\\\", \
RowBox[{\\\"\\\\\\\"a\\\\\\\"\\\", \\\"\[Rule]\\\", \\\"\\\\\\\"270\\\\\\\"\\\
\"}], \\\",\\\", RowBox[{\\\"\\\\\\\"name\\\\\\\"\\\", \\\"\[Rule]\\\", \
\\\"\\\\\\\"event3\\\\\\\"\\\"}]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"}\\\"}]}], \\\"]\\\"}]}], \\\"}\\\"}]}], \
\\\"]\\\"}]}], \\\"}\\\"}]}], \\\"]\\\"}]}], \\\"]\\\"}]\\) is not a list of \
contents. The third item in an XMLElement must be a list of contents, even if \
it is an empty list.\"",2,84,31,19014042857157888424,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.753532885828144*^9, 3.7535329140382867`*^9}, 
   3.7535331349449224`*^9, {3.755021329155275*^9, 3.755021366659608*^9}, 
   3.7550303363828263`*^9, 3.755099488643869*^9, 3.755099527170148*^9, 
   3.7550997878733644`*^9, {3.7550998204387884`*^9, 3.7550998270959263`*^9}, {
   3.7551002785250273`*^9, 3.7551002920360975`*^9}, 3.7551003530740137`*^9, 
   3.7551004422470765`*^9, 3.7551004782090006`*^9, 3.755100585945923*^9, 
   3.755101133012299*^9, 3.755101308445428*^9, {3.7551015579927855`*^9, 
   3.7551015780371203`*^9}, 3.7551017590570126`*^9, 3.7551045062177305`*^9, 
   3.7552831650126696`*^9, 3.7571798149016824`*^9, {3.7574378852958965`*^9, 
   3.757437889949091*^9}, 3.7574481008258905`*^9, 3.7632035003979006`*^9, 
   3.7632035736738987`*^9, 3.763204822793942*^9, 3.7632050104028273`*^9, 
   3.7653658114788456`*^9, 3.7747942097933083`*^9, 3.774795582694857*^9, 
   3.774862966540056*^9, 3.7753178242947607`*^9, 3.783933603848233*^9},
 CellLabel->
  "During evaluation of \
In[84]:=",ExpressionUUID->"76ff43ed-3ee0-4554-a868-23fe63b7c7b4"],

Cell[BoxData[
 TemplateBox[{
  "Export","autofix",
   "\"Malformed symbolic XML expression encountered. This may result in \
unexpected XML data.\"",2,84,32,19014042857157888424,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.753532885828144*^9, 3.7535329140382867`*^9}, 
   3.7535331349449224`*^9, {3.755021329155275*^9, 3.755021366659608*^9}, 
   3.7550303363828263`*^9, 3.755099488643869*^9, 3.755099527170148*^9, 
   3.7550997878733644`*^9, {3.7550998204387884`*^9, 3.7550998270959263`*^9}, {
   3.7551002785250273`*^9, 3.7551002920360975`*^9}, 3.7551003530740137`*^9, 
   3.7551004422470765`*^9, 3.7551004782090006`*^9, 3.755100585945923*^9, 
   3.755101133012299*^9, 3.755101308445428*^9, {3.7551015579927855`*^9, 
   3.7551015780371203`*^9}, 3.7551017590570126`*^9, 3.7551045062177305`*^9, 
   3.7552831650126696`*^9, 3.7571798149016824`*^9, {3.7574378852958965`*^9, 
   3.757437889949091*^9}, 3.7574481008258905`*^9, 3.7632035003979006`*^9, 
   3.7632035736738987`*^9, 3.763204822793942*^9, 3.7632050104028273`*^9, 
   3.7653658114788456`*^9, 3.7747942097933083`*^9, 3.774795582694857*^9, 
   3.774862966540056*^9, 3.7753178242947607`*^9, 3.7839336039082193`*^9},
 CellLabel->
  "During evaluation of \
In[84]:=",ExpressionUUID->"dfa857ec-dcfe-42a8-9bec-6439f25007b7"],

Cell[BoxData[
 TemplateBox[{
  "XMLElement","attrhs",
   "\"\\!\\(\\*RowBox[{\\\"0.25`\\\"}]\\) in \\!\\(\\*RowBox[{\\\"\\\\\\\"y\\\
\\\\\"\\\", \\\"\[Rule]\\\", \\\"0.25`\\\"}]\\) is not a valid value for an \
attribute in an XMLElement. The value of the attribute must be a string.\"",2,
   84,33,19014042857157888424,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.753532885828144*^9, 3.7535329140382867`*^9}, 
   3.7535331349449224`*^9, {3.755021329155275*^9, 3.755021366659608*^9}, 
   3.7550303363828263`*^9, 3.755099488643869*^9, 3.755099527170148*^9, 
   3.7550997878733644`*^9, {3.7550998204387884`*^9, 3.7550998270959263`*^9}, {
   3.7551002785250273`*^9, 3.7551002920360975`*^9}, 3.7551003530740137`*^9, 
   3.7551004422470765`*^9, 3.7551004782090006`*^9, 3.755100585945923*^9, 
   3.755101133012299*^9, 3.755101308445428*^9, {3.7551015579927855`*^9, 
   3.7551015780371203`*^9}, 3.7551017590570126`*^9, 3.7551045062177305`*^9, 
   3.7552831650126696`*^9, 3.7571798149016824`*^9, {3.7574378852958965`*^9, 
   3.757437889949091*^9}, 3.7574481008258905`*^9, 3.7632035003979006`*^9, 
   3.7632035736738987`*^9, 3.763204822793942*^9, 3.7632050104028273`*^9, 
   3.7653658114788456`*^9, 3.7747942097933083`*^9, 3.774795582694857*^9, 
   3.774862966540056*^9, 3.7753178242947607`*^9, 3.7839336041041718`*^9},
 CellLabel->
  "During evaluation of \
In[84]:=",ExpressionUUID->"09d2bd23-7376-46e8-9475-096e75678d98"],

Cell[BoxData[
 TemplateBox[{
  "Export","autofix",
   "\"Malformed symbolic XML expression encountered. This may result in \
unexpected XML data.\"",2,84,34,19014042857157888424,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.753532885828144*^9, 3.7535329140382867`*^9}, 
   3.7535331349449224`*^9, {3.755021329155275*^9, 3.755021366659608*^9}, 
   3.7550303363828263`*^9, 3.755099488643869*^9, 3.755099527170148*^9, 
   3.7550997878733644`*^9, {3.7550998204387884`*^9, 3.7550998270959263`*^9}, {
   3.7551002785250273`*^9, 3.7551002920360975`*^9}, 3.7551003530740137`*^9, 
   3.7551004422470765`*^9, 3.7551004782090006`*^9, 3.755100585945923*^9, 
   3.755101133012299*^9, 3.755101308445428*^9, {3.7551015579927855`*^9, 
   3.7551015780371203`*^9}, 3.7551017590570126`*^9, 3.7551045062177305`*^9, 
   3.7552831650126696`*^9, 3.7571798149016824`*^9, {3.7574378852958965`*^9, 
   3.757437889949091*^9}, 3.7574481008258905`*^9, 3.7632035003979006`*^9, 
   3.7632035736738987`*^9, 3.763204822793942*^9, 3.7632050104028273`*^9, 
   3.7653658114788456`*^9, 3.7747942097933083`*^9, 3.774795582694857*^9, 
   3.774862966540056*^9, 3.7753178242947607`*^9, 3.7839336041281643`*^9},
 CellLabel->
  "During evaluation of \
In[84]:=",ExpressionUUID->"6a5823bc-facd-4a54-bcfd-26e0fa38e28d"],

Cell[BoxData[
 TemplateBox[{
  "XMLElement","attrhs",
   "\"\\!\\(\\*RowBox[{\\\"0.5`\\\"}]\\) in \
\\!\\(\\*RowBox[{\\\"\\\\\\\"y\\\\\\\"\\\", \\\"\[Rule]\\\", \
\\\"0.5`\\\"}]\\) is not a valid value for an attribute in an XMLElement. The \
value of the attribute must be a string.\"",2,84,35,19014042857157888424,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.753532885828144*^9, 3.7535329140382867`*^9}, 
   3.7535331349449224`*^9, {3.755021329155275*^9, 3.755021366659608*^9}, 
   3.7550303363828263`*^9, 3.755099488643869*^9, 3.755099527170148*^9, 
   3.7550997878733644`*^9, {3.7550998204387884`*^9, 3.7550998270959263`*^9}, {
   3.7551002785250273`*^9, 3.7551002920360975`*^9}, 3.7551003530740137`*^9, 
   3.7551004422470765`*^9, 3.7551004782090006`*^9, 3.755100585945923*^9, 
   3.755101133012299*^9, 3.755101308445428*^9, {3.7551015579927855`*^9, 
   3.7551015780371203`*^9}, 3.7551017590570126`*^9, 3.7551045062177305`*^9, 
   3.7552831650126696`*^9, 3.7571798149016824`*^9, {3.7574378852958965`*^9, 
   3.757437889949091*^9}, 3.7574481008258905`*^9, 3.7632035003979006`*^9, 
   3.7632035736738987`*^9, 3.763204822793942*^9, 3.7632050104028273`*^9, 
   3.7653658114788456`*^9, 3.7747942097933083`*^9, 3.774795582694857*^9, 
   3.774862966540056*^9, 3.7753178242947607`*^9, 3.783933604148158*^9},
 CellLabel->
  "During evaluation of \
In[84]:=",ExpressionUUID->"ac828d08-81de-41ce-ada3-e69cfc0a22cf"],

Cell[BoxData[
 TemplateBox[{
  "Export","autofix",
   "\"Malformed symbolic XML expression encountered. This may result in \
unexpected XML data.\"",2,84,36,19014042857157888424,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.753532885828144*^9, 3.7535329140382867`*^9}, 
   3.7535331349449224`*^9, {3.755021329155275*^9, 3.755021366659608*^9}, 
   3.7550303363828263`*^9, 3.755099488643869*^9, 3.755099527170148*^9, 
   3.7550997878733644`*^9, {3.7550998204387884`*^9, 3.7550998270959263`*^9}, {
   3.7551002785250273`*^9, 3.7551002920360975`*^9}, 3.7551003530740137`*^9, 
   3.7551004422470765`*^9, 3.7551004782090006`*^9, 3.755100585945923*^9, 
   3.755101133012299*^9, 3.755101308445428*^9, {3.7551015579927855`*^9, 
   3.7551015780371203`*^9}, 3.7551017590570126`*^9, 3.7551045062177305`*^9, 
   3.7552831650126696`*^9, 3.7571798149016824`*^9, {3.7574378852958965`*^9, 
   3.757437889949091*^9}, 3.7574481008258905`*^9, 3.7632035003979006`*^9, 
   3.7632035736738987`*^9, 3.763204822793942*^9, 3.7632050104028273`*^9, 
   3.7653658114788456`*^9, 3.7747942097933083`*^9, 3.774795582694857*^9, 
   3.774862966540056*^9, 3.7753178242947607`*^9, 3.7839336041721535`*^9},
 CellLabel->
  "During evaluation of \
In[84]:=",ExpressionUUID->"007fff6f-42a3-4aca-b643-f8f2aca075c0"],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Export\\\", \\\"::\\\", \
\\\"autofix\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,84,37,19014042857157888424,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.753532885828144*^9, 3.7535329140382867`*^9}, 
   3.7535331349449224`*^9, {3.755021329155275*^9, 3.755021366659608*^9}, 
   3.7550303363828263`*^9, 3.755099488643869*^9, 3.755099527170148*^9, 
   3.7550997878733644`*^9, {3.7550998204387884`*^9, 3.7550998270959263`*^9}, {
   3.7551002785250273`*^9, 3.7551002920360975`*^9}, 3.7551003530740137`*^9, 
   3.7551004422470765`*^9, 3.7551004782090006`*^9, 3.755100585945923*^9, 
   3.755101133012299*^9, 3.755101308445428*^9, {3.7551015579927855`*^9, 
   3.7551015780371203`*^9}, 3.7551017590570126`*^9, 3.7551045062177305`*^9, 
   3.7552831650126696`*^9, 3.7571798149016824`*^9, {3.7574378852958965`*^9, 
   3.757437889949091*^9}, 3.7574481008258905`*^9, 3.7632035003979006`*^9, 
   3.7632035736738987`*^9, 3.763204822793942*^9, 3.7632050104028273`*^9, 
   3.7653658114788456`*^9, 3.7747942097933083`*^9, 3.774795582694857*^9, 
   3.774862966540056*^9, 3.7753178242947607`*^9, 3.7839336042886777`*^9},
 CellLabel->
  "During evaluation of \
In[84]:=",ExpressionUUID->"c519699f-3054-42fd-b694-3a18e2e4fcff"],

Cell[BoxData[
 TemplateBox[{
  "XMLElement","attrhs",
   "\"\\!\\(\\*RowBox[{\\\"0.75`\\\"}]\\) in \\!\\(\\*RowBox[{\\\"\\\\\\\"y\\\
\\\\\"\\\", \\\"\[Rule]\\\", \\\"0.75`\\\"}]\\) is not a valid value for an \
attribute in an XMLElement. The value of the attribute must be a string.\"",2,
   84,38,19014042857157888424,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.753532885828144*^9, 3.7535329140382867`*^9}, 
   3.7535331349449224`*^9, {3.755021329155275*^9, 3.755021366659608*^9}, 
   3.7550303363828263`*^9, 3.755099488643869*^9, 3.755099527170148*^9, 
   3.7550997878733644`*^9, {3.7550998204387884`*^9, 3.7550998270959263`*^9}, {
   3.7551002785250273`*^9, 3.7551002920360975`*^9}, 3.7551003530740137`*^9, 
   3.7551004422470765`*^9, 3.7551004782090006`*^9, 3.755100585945923*^9, 
   3.755101133012299*^9, 3.755101308445428*^9, {3.7551015579927855`*^9, 
   3.7551015780371203`*^9}, 3.7551017590570126`*^9, 3.7551045062177305`*^9, 
   3.7552831650126696`*^9, 3.7571798149016824`*^9, {3.7574378852958965`*^9, 
   3.757437889949091*^9}, 3.7574481008258905`*^9, 3.7632035003979006`*^9, 
   3.7632035736738987`*^9, 3.763204822793942*^9, 3.7632050104028273`*^9, 
   3.7653658114788456`*^9, 3.7747942097933083`*^9, 3.774795582694857*^9, 
   3.774862966540056*^9, 3.7753178242947607`*^9, 3.7839336043043046`*^9},
 CellLabel->
  "During evaluation of \
In[84]:=",ExpressionUUID->"38d286a5-2bd2-4211-92d5-4572295974f6"],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"XMLElement\\\", \
\\\"::\\\", \\\"attrhs\\\"}], \\\"MessageName\\\"]\\) will be suppressed \
during this calculation.\"",2,84,39,19014042857157888424,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 CellChangeTimes->{{3.753532885828144*^9, 3.7535329140382867`*^9}, 
   3.7535331349449224`*^9, {3.755021329155275*^9, 3.755021366659608*^9}, 
   3.7550303363828263`*^9, 3.755099488643869*^9, 3.755099527170148*^9, 
   3.7550997878733644`*^9, {3.7550998204387884`*^9, 3.7550998270959263`*^9}, {
   3.7551002785250273`*^9, 3.7551002920360975`*^9}, 3.7551003530740137`*^9, 
   3.7551004422470765`*^9, 3.7551004782090006`*^9, 3.755100585945923*^9, 
   3.755101133012299*^9, 3.755101308445428*^9, {3.7551015579927855`*^9, 
   3.7551015780371203`*^9}, 3.7551017590570126`*^9, 3.7551045062177305`*^9, 
   3.7552831650126696`*^9, 3.7571798149016824`*^9, {3.7574378852958965`*^9, 
   3.757437889949091*^9}, 3.7574481008258905`*^9, 3.7632035003979006`*^9, 
   3.7632035736738987`*^9, 3.763204822793942*^9, 3.7632050104028273`*^9, 
   3.7653658114788456`*^9, 3.7747942097933083`*^9, 3.774795582694857*^9, 
   3.774862966540056*^9, 3.7753178242947607`*^9, 3.7839336043199244`*^9},
 CellLabel->
  "During evaluation of \
In[84]:=",ExpressionUUID->"2e2c0e96-81cd-4686-a8fb-6e8f22e38def"]
}, Open  ]]
},
WindowSize->{862, 669},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 271, 5, 96, "Title",ExpressionUUID->"5ee7c9b3-61b3-495d-947e-36f10d487fd4",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[853, 29, 375, 6, 28, "Input",ExpressionUUID->"fb626f91-feab-4a07-b722-dbbcc151c4cc",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[1231, 37, 681, 13, 48, "Input",ExpressionUUID->"f08428ac-a507-4dcf-b70e-fed094d55f5a",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}]
}, Open  ]],
Cell[1927, 53, 253, 3, 32, "Output",ExpressionUUID->"1a41fbbe-4cae-413c-9835-7598e46f812a"],
Cell[2183, 58, 535, 11, 48, "Input",ExpressionUUID->"3942318d-c5ab-4bbb-b9f9-af1d93363738",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[2721, 71, 270, 3, 32, "Output",ExpressionUUID->"6e065920-ee9c-4f29-ad85-37cfb9be7634"],
Cell[CellGroupData[{
Cell[3016, 78, 299, 6, 28, "Input",ExpressionUUID->"96c62941-67ee-4f41-b96b-bc238faf7f2f",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[3318, 86, 697, 11, 67, "Section",ExpressionUUID->"579c246d-7234-4bbc-a83d-653b42f152d9",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[4018, 99, 578, 11, 56, "Text",ExpressionUUID->"bdc3e281-aa00-44be-ae84-967524ca58f1",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[4599, 112, 2053, 42, 200, "Input",ExpressionUUID->"c12350b7-5012-4a2e-bec0-d7181fc31046",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[6655, 156, 1224, 17, 32, "Output",ExpressionUUID->"565c5faf-895b-4afd-a9ec-6c5289b0951e",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[7882, 175, 1289, 20, 32, "Output",ExpressionUUID->"de71617e-5329-4b4c-90a5-a75119ee28f7",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[9174, 197, 1123, 21, 105, "Input",ExpressionUUID->"2096f5b3-005e-4e58-a8bb-ee5cca97f503",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[10300, 220, 1641, 29, 86, "Input",ExpressionUUID->"84b1787a-183b-4920-a69d-4df94c20bba2",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[11944, 251, 487, 11, 67, "Input",ExpressionUUID->"0c74128b-2532-4223-a2a4-740b1043b57b",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[12434, 264, 601, 12, 86, "Input",ExpressionUUID->"e5511e4a-3353-4719-a540-40dff57756df",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[13038, 278, 2872, 54, 181, "Input",ExpressionUUID->"3cfb1a01-c132-42a5-9718-0d816c76266d",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[15913, 334, 259, 4, 28, "Input",ExpressionUUID->"2ac98d27-7834-4af5-8633-0d47fd58d28b",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[16175, 340, 1021, 15, 52, "Output",ExpressionUUID->"b052cbd8-eb76-426e-934e-f2f7007b974a",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[17199, 357, 241, 4, 28, "Input",ExpressionUUID->"15f971df-cb2f-4ac0-8bbd-ca375d983568",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[17443, 363, 6648, 98, 148, "Message",ExpressionUUID->"76ff43ed-3ee0-4554-a868-23fe63b7c7b4",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[24094, 463, 1356, 22, 21, "Message",ExpressionUUID->"dfa857ec-dcfe-42a8-9bec-6439f25007b7",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[25453, 487, 1498, 24, 21, "Message",ExpressionUUID->"09d2bd23-7376-46e8-9475-096e75678d98",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[26954, 513, 1356, 22, 21, "Message",ExpressionUUID->"6a5823bc-facd-4a54-bcfd-26e0fa38e28d",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[28313, 537, 1496, 25, 21, "Message",ExpressionUUID->"ac828d08-81de-41ce-ada3-e69cfc0a22cf",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[29812, 564, 1356, 22, 21, "Message",ExpressionUUID->"007fff6f-42a3-4aca-b643-f8f2aca075c0",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[31171, 588, 1428, 23, 21, "Message",ExpressionUUID->"c519699f-3054-42fd-b694-3a18e2e4fcff",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[32602, 613, 1498, 24, 21, "Message",ExpressionUUID->"38d286a5-2bd2-4211-92d5-4572295974f6",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}],
Cell[34103, 639, 1431, 23, 21, "Message",ExpressionUUID->"2e2c0e96-81cd-4686-a8fb-6e8f22e38def",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.}]
}, Open  ]]
}
]
*)

